package com.crm.pay.controller.pay;

import com.crm.pay.controller.base.BasePayCloseFunctionController;
import com.crm.pay.entity.callback.PartnerPayCallbackEntity;
import com.crm.pay.service.PartnerPayService;
import com.crm.rely.backend.core.constant.Constants;
import com.crm.rely.backend.core.constant.FeignClientAnnotation;
import com.crm.rely.backend.model.constant.PayConstants;
import com.crm.rely.backend.core.dto.base.BaseResultDto;
import com.crm.pay.dto.PayDto;
import com.crm.rely.backend.model.entity.custom.info.CustomInfoEntity;
import com.crm.rely.backend.model.entity.finance.deposit.FinanceDepositAddEntity;
import com.crm.pay.entity.FinanceDepositParameterEntity;
import com.crm.pay.entity.finance.withdraw.automatic.FinanceWithdrawInfoEntity;
import com.crm.pay.entity.finance.withdraw.automatic.FinanceWithdrawPartnerEntity;
import com.crm.rely.backend.core.exception.PayValidatedException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;

@RestController
@RequestMapping("/partner")
public class PartnerPayController extends BasePayCloseFunctionController {

    @Autowired
    private PartnerPayService service;

    /**
     * 支付
     *
     * @param login  入金账号
     * @param amount 入金金额
     * @return 错误信息
     * @throws Exception
     */
    @RequestMapping("/pay/{login}/{amount}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @RequestBody FinanceDepositParameterEntity entity, HttpServletRequest request,
                             CustomInfoEntity infoEntity) throws Exception {


        return payCall(login, amount, 0, entity, infoEntity, request);
    }

    @RequestMapping("/pay/{login}/{amount}/{activity}")
    public BaseResultDto pay(@PathVariable("login") Long login,
                             @PathVariable("amount") BigDecimal amount,
                             @PathVariable("activity") int activity,
                             @RequestBody FinanceDepositParameterEntity entity, HttpServletRequest request,
                             CustomInfoEntity infoEntity) throws Exception {


        return payCall(login, amount, activity, entity, infoEntity, request);
    }

    private BaseResultDto payCall(Long login,
                                  BigDecimal amount,
                                  int activity,
                                  FinanceDepositParameterEntity entity,
                             CustomInfoEntity infoEntity, HttpServletRequest request) throws Exception {
        validated(login, amount);

        FinanceDepositAddEntity financeDepositSaveEntity = getFinanceDepositSaveEntity(login, amount,
                PayConstants.PARTNER_PAY_KEY,
                PayConstants.PARTNER_PAY_KEY, activity, entity, request);

        String url = service.pay(financeDepositSaveEntity);
        PayDto payDto = new PayDto(1, url);
        return BaseResultDto.success(payDto);
    }

    @PostMapping("/withdraw/info")
    @FeignClientAnnotation
    public BaseResultDto withdrawInfo(@RequestBody FinanceWithdrawInfoEntity entity) throws Exception {

        return BaseResultDto.success(service.withdrawInfo(entity));
    }

    @PostMapping("/withdraw")
    @FeignClientAnnotation
    public BaseResultDto withdraw(@RequestBody FinanceWithdrawPartnerEntity entity) throws Exception {
        service.withdraw(entity);

        return BaseResultDto.success();
    }

    /**
     * 异步回调
     *
     * @param callbackEntity 用于获取回调数据
     * @return 返回成功给第三方系统
     * @throws Exception
     */
    @RequestMapping(value = "/callback", produces = "text/html")
    public String callback(PartnerPayCallbackEntity callbackEntity, HttpServletResponse response) throws Exception {
        try {
            return service.callback(callbackEntity);
        } catch (Exception e) {
            return Constants.FAIL;
        }
    }

    @RequestMapping("/withdraw/callback")
    public String withdrawCallback(@RequestBody PartnerPayCallbackEntity entity) throws Exception {
        try {
            return service.withdrawCallback(1, entity);
        } catch (Exception e) {
            return Constants.FAIL;
        }

    }

    @RequestMapping("/agent/withdraw/callback")
    public String agentWithdrawCallback(PartnerPayCallbackEntity entity) throws Exception {
        try {
            return service.withdrawCallback(2, entity);
        } catch (Exception e) {
            return Constants.FAIL;
        }

    }

    @RequestMapping("/withdraw/callback/reverse")
    public String withdrawReverseCallback(PartnerPayCallbackEntity entity) throws Exception {
        try {
            return service.withdrawCallback(1, entity);
        } catch (Exception e) {
            return Constants.FAIL;
        }

    }

    @RequestMapping("/agent/withdraw/callback/reverse")
    public String agentWithdrawReverseCallback(@RequestBody PartnerPayCallbackEntity entity) throws Exception {
        try {
            return service.withdrawCallback(2, entity);
        } catch (Exception e) {
            return Constants.FAIL;
        }

    }


    /**
     * 同步页面 成功
     *
     * @param response 用于重定向页面
     * @throws IOException
     */
    @GetMapping(value = "/pickup")
    public void pickup(HttpServletResponse response) throws Exception, PayValidatedException {

        sendRedirect(response);
    }

    @GetMapping(value = "/error")
    public void error(HttpServletResponse response) throws Exception {

        sendRedirect(response);
    }
}
